Subject: Re: [PATCH net] net: stmmac: allow a tc-taprio base-time of zero

From: Kurt Kanzenbach <[email-masked]>
Date: Tue, 16 Nov 2021 13:18:53 +0100

Hi Yannick,

On Tue Nov 09 2021, Yannick Vignon wrote:
> Hi Kurt,
>
> On 11/9/2021 3:47 PM, Kurt Kanzenbach wrote:
>> On Tue Nov 09 2021, Vladimir Oltean wrote:
>>> On Tue, Nov 09, 2021 at 09:20:53AM +0100, Kurt Kanzenbach wrote:
>>>> Hi Vladimir,
>>>>
>>>> On Mon Nov 08 2021, Vladimir Oltean wrote:
>>>>> Commit fe28c53ed71d ("net: stmmac: fix taprio configuration when
>>>>> base_time is in the past") allowed some base time values in the past,
>>>>> but apparently not all, the base-time value of 0 (Jan 1st 1970) is still
>>>>> explicitly denied by the driver.
>>>>>
>>>>> Remove the bogus check.
>>>>>
>>>>> Fixes: b60189e0392f ("net: stmmac: Integrate EST with TAPRIO scheduler API")
>>>>> Signed-off-by: Vladimir Oltean <[email-masked]>
>>>>
>>>> I've experienced the same problem and wanted to send a patch for
>>>> it. Thanks!
>>>>
>>>> Reviewed-by: Kurt Kanzenbach <[email-masked]>
>>>
>>> Cool. So you had that patch queued up? What other stmmac patches do you
>>> have queued up? :).
>> 
>> I'm experiencing some problems with XDP using this driver. We're
>> currently investigating.
>
> Could you elaborate a bit?

It was a combination of oddities within the PCP based VLAN steering and
bugs in my application. No driver issues.

The last issue I have is packet loss from time to time. Still debugging.

> I've been using XDP a lot with the stmmac driver recently, and while I 
> did see issues initially, most of them got fixed by using a recent 
> enough kernel, thanks to the following commits:
> . a6451192da2691dcf39507bd ("net: stmmac: fix kernel panic due to NULL 
> pointer dereference of xsk_pool")
> . 2b9fff64f03219d78044d1ab ("net: stmmac: fix kernel panic due to NULL 
> pointer dereference of buf->xdp")
> . 81d0885d68ec427e62044cf4 ("net: stmmac: Fix overall budget calculation 
> for rxtx_napi")
>
> There was one remaining issue for which I need to push a fix: if you 
> remove an XDP program from an interface while transmitting traffic, you 
> are likely to trigger a kernel panic. I'll try to push a patch for that 
> soon.

OK, great.

Thanks,
Kurt